#include <assert.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

typedef unsigned long int uint32_t;

uint32_t file_size(const char *path)
{
	FILE *t = fopen(path, "r");
	uint32_t ret;
	assert(t);
	fseek(t, 0, SEEK_END);
	ret = ftell(t);
	fclose(t);
	return ret;
}

void append_file(FILE *dest, const char *src, uint32_t size)
{
	void *buf = malloc(size);
	FILE *s;
	assert(buf);
	s = fopen(src, "rb");
	assert(s);
	fread(buf, size, 1, s);
	fclose(s);
	fwrite(buf, size, 1, dest);
}

int main(int argc, char **argv)
{
	FILE *dest;
	uint32_t v;
	uint32_t dtb_size;
	uint32_t initrd_size;
	uint32_t kernel_size;
	if(argc != 4)
	{
		fprintf(stderr, "Usage: %s dtb initrd kernel\n", argv[0]);
		return 1;
	}
	
	dest = fopen("diags.img.tns", "wb");
	assert(dest);
	append_file(dest, "loader.bin", file_size("loader.bin"));
	v = 0xDEDC0FFE;
	fwrite(&v, sizeof(v), 1, dest);
	dtb_size = file_size(argv[1]);
	fwrite(&dtb_size, sizeof(v), 1, dest);
	initrd_size = file_size(argv[2]);
	fwrite(&initrd_size, sizeof(v), 1, dest);
	kernel_size = file_size(argv[3]);
	fwrite(&kernel_size, sizeof(v), 1, dest);
	append_file(dest, argv[1], dtb_size);
	append_file(dest, argv[2], initrd_size);
	append_file(dest, argv[3], kernel_size);
	fclose(dest);
}